<script>
import { GlLoadingIcon } from '@gitlab/ui'
import getDataManifest from '@/assets/get-data-manifest'

export default {
  name: 'DictionaryCardsPage',

  components: { GlLoadingIcon },

  async asyncData({ params, query }) {
    return {
      dataManifest: await getDataManifest(),
      namespace: params.namespace,
      keys: String(query.q)
        .split(',')
        .map((key) => String(key).trim())
        .filter(Boolean),
      providedTitle: query.title,
    }
  },

  data: () => ({
    fullResults: [],
  }),

  async fetch() {
    const namespace = this.namespace.replace('-', '_')
    const url = `data/${namespace}.${this.dataManifest[namespace]}.json`
    const response = await fetch(new URL(url, location.origin).toString())

    this.fullResults = await response.json()
  },

  head() {
    const [firstKey, ...more] = this.keys
    let title = firstKey

    if (more.length) {
      title += ` (+ ${more.length} more)`
    }

    return {
      title: this.providedTitle ?? title,
    }
  },

  computed: {
    primaryKey() {
      return {
        'service-ping': 'key_path',
        'snowplow': 'key',
      }[this.namespace]
    },

    results() {
      return this.fullResults.filter((result) =>
        this.keys.includes(result[this.primaryKey]),
      )
    },

    title() {
      if (this.providedTitle) {
        return this.providedTitle
      }

      if (this.namespace === 'service-ping') {
        return 'Service Ping metrics'
      }

      if (this.namespace === 'snowplow') {
        return 'Event definition'
      }

      return 'Unknown'
    },

    cardComponent() {
      if (this.namespace === 'service-ping') {
        return 'md-metric-card'
      }

      if (this.namespace === 'snowplow') {
        return 'md-definition-card'
      }

      return 'Unknown'
    },
  },
}
</script>

<template>
  <div class="mx-auto max-w-4xl scroll-smooth p-6">
    <h2 class="text-2xl font-semibold leading-7">{{ title }}</h2>

    <div v-if="$fetchState.pending" class="my-12 text-center">
      <gl-loading-icon size="md" />
      <span class="text-medium mt-2">Loading</span>
    </div>

    <p v-else-if="$fetchState.error" class="py-4 text-red-700">
      An error occurred
    </p>

    <p v-else-if="!results.length" class="py-4 text-amber-700">No matches</p>

    <div v-else>
      <ul
        v-if="results.length > 1"
        class="mt-2 -mb-2 divide-y divide-gray-100 font-mono text-sm"
      >
        <li
          v-for="result in results"
          :key="result[primaryKey]"
          class="whitespace-nowrap py-2"
        >
          <span class="text-xs text-gray-400">#</span>
          <a :href="`#${result[primaryKey]}`">{{ result[primaryKey] }}</a>
        </li>
      </ul>

      <div
        v-for="result in results"
        :id="result[primaryKey]"
        :key="result[primaryKey]"
        class="py-6"
      >
        <component :is="cardComponent" :item="result" />
      </div>
    </div>
  </div>
</template>
